<?php
require_once("../../config.php");
require_once($urnreg_path."/common.php");
require_once($siledap_path."/LdapConf.php");
require_once($siledap_path."/LdapManager.php");

function getURNs($lm,$type) {
	GLOBAL $URN_LDAP_BASE;
	GLOBAL $URN_VALUE_BASE;
	
	$res='';
	foreach ($URN_VALUE_BASE as $urnbase) {
		if (strcmp($type,"description")==0) {
			$filter="(&(|(objectClass=urnRegDescription)(objectClass=urnRegDescriptionStr))(|(urnRegValue=".$urnbase.":*)(urnRegValue=".$urnbase.")))";
		}
		else {
			$filter="(&(|(objectClass=urnRegDelegation)(objectClass=urnRegDelegationStr))(|(urnRegValue=".$urnbase.":*)(urnRegValue=".$urnbase.")))";
		}
		$entries=$lm->search($URN_LDAP_BASE,$filter,false);
		usort($entries,"sortSubUrns");
		foreach ($entries as $entry) {
			if (strcmp($type,"description")==0) {
				$res.=echoURNDescription($entry);
			}
			else {
				$res.=echoURNDelegation($entry);
			}
		}
	}
	
	return $res;
}

$lm=new LdapManager($LDAP_SERVER_NAME,$LDAP_SERVER_PORT);
$lm->setOption(LDAP_OPT_PROTOCOL_VERSION,3);
$lm->connectLdap($LDAP_USER,$LDAP_PASS);

$success=false;

$type='description';
if (array_key_exists('type',$_REQUEST)) {
	$type=$_REQUEST['type'];
}
$format='human';
if (array_key_exists('format',$_REQUEST)) {
	$format=$_REQUEST['format'];
}
if (strcmp($format,"machine")==0) {
	header('Content-type: text/xml');
	echo "<Response>";
	echo "<urns>";
	echo getURNs($lm,$type);
	echo "</urns>";
	echo "</Response>";
}
else {
	$data="<urns>".getURNs($lm,$type)."</urns>";
	$xml = DOMDocument::loadXML($data);
	$xsl = new DomDocument;
	if (strcmp($type,"description")==0) {
		$xsl->load('template.xslt');
	}
	else {
		$xsl->load('template-delegated.xslt');
	}
			
	$proc = new XSLTProcessor;
	$proc->importStyleSheet($xsl);
	$proc->setParameter('','uri',"../search/?urn=");
	echo($proc->transformToXML($xml));
}

?>